#include "mbed.h"
#include "VodafoneUSBModem.h"
#include "HTTPClient.h"

Mutex mutex;
bool flag;
// objects
Serial pc(USBTX, USBRX);
void test(void const*) 
{


  
    VodafoneUSBModem modem;
    HTTPClient http;
    char str[512];
    
    
    int ret = modem.connect("pp.vodafone.co.uk");
    if(ret)
    {
      pc.printf("Could not connect\n");
      return;
    }
    
    //GET data
    pc.printf("Trying to fetch page...\n");
    ret = http.get("http://mbed.org/media/uploads/donatien/hello.txt", str, 128);
    if (!ret)
    {
      pc.printf("Page fetched successfully - read %d characters\n", strlen(str));
      pc.printf("Result: %s\n", str);
    }
    else
    {
      printf("Error - ret = %d - HTTP return code = %d\n", ret, http.getHTTPResponseCode());
    }
    
    //POST data
    HTTPMap map;
    HTTPText text(str, 512);
    map.put("Hello", "World");
    map.put("test", "1234");
    printf("Trying to post data...\n");
    ret = http.post("http://httpbin.org/post", map, &text);
    if (!ret)
    {
      pc.printf("\n\rExecuted POST successfully - read %d characters\n", strlen(str));
      pc.printf("\n\rResult: %s\n", str);
    }
    else
    {
      pc.printf("\n\rError: \n\rret = %d  \n\rHTTP return code = %d\n", ret, http.getHTTPResponseCode());
    }
    
    modem.disconnect();  

    mutex.lock();
    flag = true; // prevent the main function from using it
    mutex.unlock();
    
    while(1) {// wait ....
    } 
    
    
}


int main()
{
  DigitalOut led(LED1);

  while(1) 
  {
    flag = false;
    // create new thread...
    Thread testTask(test, NULL, osPriorityNormal, 1024 * 4);
  
    while(1) { // wait for thread to finish its activity
      mutex.lock();
      if( flag) 
      { // prevent the thread from using it..
          break;
          mutex.unlock();
      }
    }
     testTask.terminate(); //delete thread
     pc.printf("\n\rRestart");

   
    Thread::wait(1000);  
  }

  return 0;
}